Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXViewer.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXViewer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXViewer.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLXViewer.cc,v 1.34 2006/11/01 11:22:26 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenGLXViewer.cc,v 1.42 2007/05/25 10:47:17 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -77,39 +77,9 @@
 #define USE_STANDARD_COLORMAP 0
 
-static const char* gouraudtriangleEPS[] =
-{
-  "/bd{bind def}bind def /triangle { aload pop   setrgbcolor  aload pop 5 3",
-  "roll 4 2 roll 3 2 roll exch moveto lineto lineto closepath fill } bd",
-  "/computediff1 { 2 copy sub abs threshold ge {pop pop pop true} { exch 2",
-  "index sub abs threshold ge { pop pop true} { sub abs threshold ge } ifelse",
-  "} ifelse } bd /computediff3 { 3 copy 0 get 3 1 roll 0 get 3 1 roll 0 get",
-  "computediff1 {true} { 3 copy 1 get 3 1 roll 1 get 3 1 roll 1 get",
-  "computediff1 {true} { 3 copy 2 get 3 1 roll  2 get 3 1 roll 2 get",
-  "computediff1 } ifelse } ifelse } bd /middlecolor { aload pop 4 -1 roll",
-  "aload pop 4 -1 roll add 2 div 5 1 roll 3 -1 roll add 2 div 3 1 roll add 2",
-  "div 3 1 roll exch 3 array astore } bd /gouraudtriangle { computediff3 { 4",
-  "-1 roll aload 7 1 roll 6 -1 roll pop 3 -1 roll pop add 2 div 3 1 roll add",
-  "2 div exch 3 -1 roll aload 7 1 roll exch pop 4 -1 roll pop add 2 div 3 1",
-  "roll add 2 div exch 3 -1 roll aload 7 1 roll pop 3 -1 roll pop add 2 div 3",
-  "1 roll add 2 div exch 7 3 roll 10 -3 roll dup 3 index middlecolor 4 1 roll",
-  "2 copy middlecolor 4 1 roll 3 copy pop middlecolor 4 1 roll 13 -1 roll",
-  "aload pop 17 index 6 index 15 index 19 index 6 index 17 index 6 array",
-  "astore 10 index 10 index 14 index gouraudtriangle 17 index 5 index 17",
-  "index 19 index 5 index 19 index 6 array astore 10 index 9 index 13 index",
-  "gouraudtriangle 13 index 16 index 5 index 15 index 18 index 5 index 6",
-  "array astore 12 index 12 index 9 index gouraudtriangle 17 index 16 index",
-  "15 index 19 index 18 index 17 index 6 array astore 10 index 12 index 14",
-  "index gouraudtriangle 18 {pop} repeat } { aload pop 5 3 roll aload pop 7 3",
-  "roll aload pop 9 3 roll 4 index 6 index 4 index add add 3 div 10 1 roll 7",
-  "index 5 index 3 index add add 3 div 10 1 roll 6 index 4 index 2 index add",
-  "add 3 div 10 1 roll 9 {pop} repeat 3 array astore triangle } ifelse } bd",
-  NULL
-};
-
 XVisualInfo*  G4OpenGLXViewer::vi_single_buffer = 0;
 XVisualInfo*  G4OpenGLXViewer::vi_double_buffer = 0;
 
 extern "C" {
-  Bool G4OpenGLXViewerWaitForNotify (Display*, XEvent* e, char* arg) {
+  static Bool G4OpenGLXViewerWaitForNotify (Display*, XEvent* e, char* arg) {
     return (e->type == MapNotify) && (e->xmap.window == (Window) arg);
   }
@@ -125,4 +95,19 @@
                 //be propagated before progressing.
   glFlush ();
+
+  if (fVP.IsPicking()) {
+    G4cout <<
+      "Window activated for picking (left-mouse), exit (middle-mouse)."
+	   << G4endl;
+    while (true) {
+      if (XPending(dpy)) {
+	XNextEvent(dpy, &event);
+	if (event.type == ButtonPress && event.xbutton.button == 1) {
+	  Pick(event.xbutton.x, event.xbutton.y);
+	}
+	else if (event.type == ButtonPress && event.xbutton.button == 2) break;
+      }
+    }
+  }
 }
 
@@ -181,4 +166,5 @@
   
   if (status == 1) {
+    cmap = 0;
     status = XGetRGBColormaps (dpy, 
 			       XRootWindow (dpy, vi -> screen), 
@@ -187,9 +173,18 @@
 			       XA_RGB_DEFAULT_MAP);
     if (status == 1)
-      for (i = 0; i < numCmaps; i++)
+      for (i = 0; i < numCmaps; i++) {
 	if (standardCmaps[i].visualid == vi -> visualid) {
 	  cmap = standardCmaps[i].colormap;
 	  XFree (standardCmaps);
+	  break;
 	}
+      }
+    if (!cmap) {
+      fViewId = -1;  // This flags an error.
+      G4cerr <<
+   "G4OpenGLViewer::G4OpenGLViewer failed to allocate a standard colormap."
+	     << G4endl;
+      return;
+    }
     G4cout << "Got standard cmap" << G4endl;
   } else {
@@ -298,5 +293,15 @@
 
 // connect the context to a window
-  glXMakeCurrent (dpy, win, cx);
+  Bool success = glXMakeCurrent (dpy, win, cx);
+  if (!success) {
+    fViewId = -1;  // This flags an error.
+    G4cerr << "G4OpenGLViewer::G4OpenGLViewer failed to attach a GLX context."
+	 << G4endl;
+    GLint error = GL_NO_ERROR;
+    while ((error = glGetError()) != GL_NO_ERROR) {
+      G4cout << "GL Error: " << gluErrorString(error) << G4endl;
+    }
+    return;
+  }
 
 }
@@ -342,12 +347,9 @@
 G4VViewer (scene, -1),
 G4OpenGLViewer (scene),
-print_colour (true),
-vectored_ps (true),
 vi_immediate (0),
-vi_stored (0)
+vi_stored (0),
+vi (0),
+cmap (0)
 {
-
-  strcpy (print_string, "G4OpenGL.eps");
-
   GetXConnection ();
   if (fViewId < 0) return;
@@ -432,29 +434,6 @@
   
   if (vectored_ps) {
-    G4int size = 5000000;
-    
-    GLfloat* feedback_buffer;
-    GLint returned;
-    FILE* file;
-    
-    feedback_buffer = new GLfloat[size];
-    glFeedbackBuffer (size, GL_3D_COLOR, feedback_buffer);
-    glRenderMode (GL_FEEDBACK);
-    
-    DrawView();
-    returned = glRenderMode (GL_RENDER);
-    
-    if (print_string) {
-      file = fopen (print_string, "w");
-      if (file) {
-	spewWireframeEPS (file, returned, feedback_buffer, "rendereps");
-      } else {
-	printf("Could not open %s\n", print_string);
-      }
-    } else {
-      printBuffer (returned, feedback_buffer);
-    }
-    //  free (feedback_buffer);
-    delete[] feedback_buffer;
+
+    G4OpenGLViewer::print();
 
   } else {
@@ -462,4 +441,10 @@
     XVisualInfo* pvi;
     GLXContext pcx = create_GL_print_context(pvi);
+
+    if (!pcx) {
+      G4cout << "Unable to create print context." << G4endl;
+      return;
+    }
+
     GLXContext tmp_cx;
     tmp_cx = cx;
@@ -480,5 +465,5 @@
     
     glXMakeCurrent (dpy,
-		    glxpmap,
+		    win,
 		    cx);
     
@@ -486,4 +471,5 @@
     
     ClearView ();
+    SetView ();
     DrawView ();
     
@@ -496,5 +482,5 @@
     
     glXMakeCurrent (dpy,
-		    glxpmap,
+		    win,
 		    cx);
     
@@ -503,462 +489,51 @@
 }
 
-void G4OpenGLXViewer::print3DcolorVertex(GLint size, GLint * count, GLfloat * buffer)
-{
-  G4int i;
-
-  printf("  ");
-  for (i = 0; i < 7; i++) {
-    printf("%4.2f ", buffer[size - (*count)]);
-    *count = *count - 1;
-  }
-  printf("\n");
-}
-
-void G4OpenGLXViewer::spewWireframeEPS (FILE* file, GLint size, GLfloat* buffer, const char* cr) {
-
-  GLfloat EPS_GOURAUD_THRESHOLD=0.1;
-
-  GLfloat clearColor[4], viewport[4];
-  GLfloat lineWidth;
-  G4int i;
-
-  glGetFloatv (GL_VIEWPORT, viewport);
-  glGetFloatv (GL_COLOR_CLEAR_VALUE, clearColor);
-  glGetFloatv (GL_LINE_WIDTH, &lineWidth);
-  glGetFloatv (GL_POINT_SIZE, &pointSize);
-
-  fputs ("%!PS-Adobe-2.0 EPSF-2.0\n", file);
-  fprintf (file, "%%%%Creator: %s (using OpenGL feedback)\n", cr);
-  fprintf (file, "%%%%BoundingBox: %g %g %g %g\n", viewport[0], viewport[1], viewport[2], viewport[3]);
-  fputs ("%%EndComments\n", file);
-  fputs ("\n", file);
-  fputs ("gsave\n", file);
-  fputs ("\n", file);
-
-  fputs ("% the gouraudtriangle PostScript fragment below is free\n", file);
-  fputs ("% written by Frederic Delhoume (delhoume@ilog.fr)\n", file);
-  fprintf (file, "/threshold %g def\n", EPS_GOURAUD_THRESHOLD);
-  for (i=0; gouraudtriangleEPS[i]; i++) {
-    fprintf (file, "%s\n", gouraudtriangleEPS[i]);
-  }
-
-  fprintf(file, "\n%g setlinewidth\n", lineWidth);
-  
-  fprintf (file, "%g %g %g setrgbcolor\n", clearColor[0], clearColor[1], clearColor[2]);
-  fprintf (file, "%g %g %g %g rectfill\n\n", viewport[0], viewport[1], viewport[2], viewport[3]);
-
-  spewSortedFeedback (file, size, buffer);
-
-  fputs ("grestore\n\n", file);
-  fputs ("showpage\n", file);
-
-  fclose(file);
-}
-
-void G4OpenGLXViewer::printBuffer (GLint size, GLfloat* buffer) {
-
-  GLint count;
-  G4int token, nvertices;
-
-  count=size;
-  while(count) {
-    token=G4int (buffer[size-count]);
-    count--;
-    switch (token) {
-
-    case GL_PASS_THROUGH_TOKEN:
-      printf ("GL_PASS_THROUGH_TOKEN\n");
-      printf ("  %4.2f\n", buffer[size-count]);
-      count--;
-      break;
-
-    case GL_POINT_TOKEN:
-      printf ("GL_POINT_TOKEN\n");
-      print3DcolorVertex (size, &count, buffer);
-      break;
-
-    case GL_LINE_TOKEN:
-      printf ("GL_LINE_TOKEN\n");
-      print3DcolorVertex (size, &count, buffer);
-      print3DcolorVertex (size, &count, buffer);
-      break;
-      
-    case GL_LINE_RESET_TOKEN:
-      printf ("GL_LINE_RESET_TOKEN\n");
-      print3DcolorVertex (size, &count, buffer);
-      print3DcolorVertex (size, &count, buffer);
-      break;
-
-    case GL_POLYGON_TOKEN:
-      printf ("GL_POLYGON_TOKEN\n");
-      nvertices=G4int (buffer[size-count]);
-      count--;
-      for (; nvertices>0; nvertices--) {
-	print3DcolorVertex (size, &count, buffer);
-      }
-    }
-  }
-}
-
-G4float* G4OpenGLXViewer::spewPrimitiveEPS (FILE* file, GLfloat* loc) {
-  
-  G4int token;
-  G4int nvertices, i;
-  GLfloat red, green, blue, intensity;
-  G4int smooth;
-  GLfloat dx, dy, dr, dg, db, absR, absG, absB, colormax;
-  G4int steps;
-  Feedback3Dcolor *vertex;
-  GLfloat xstep(0.), ystep(0.), rstep(0.), gstep(0.), bstep(0.);
-  GLfloat xnext(0.), ynext(0.), rnext(0.), gnext(0.), bnext(0.), distance(0.);
-
-  token=G4int (*loc);
-  loc++;
-  switch (token) {
-  case GL_LINE_RESET_TOKEN:
-  case GL_LINE_TOKEN:
-    vertex=(Feedback3Dcolor*)loc;
-    dr=vertex[1].red - vertex[0].red;
-    dg=vertex[1].green - vertex[0].green;
-    db=vertex[1].blue - vertex[0].blue;
-
-    if (!print_colour) {
-      dr+=(dg+db);
-      dr/=3.0;
-      dg=dr;
-      db=dr;
-    }
-
-    if (dr!=0 || dg!=0 || db!=0) {
-      dx=vertex[1].x - vertex[0].x;
-      dy=vertex[1].y - vertex[0].y;
-      distance=std::sqrt(dx*dx + dy*dy);
-
-      absR=std::fabs(dr);
-      absG=std::fabs(dg);
-      absB=std::fabs(db);
-
-      #define Max(a, b) (((a)>(b))?(a):(b))
-
-      #define EPS_SMOOTH_LINE_FACTOR 0.06
-
-      colormax=Max(absR, Max(absG, absB));
-      steps=Max(1, G4int (colormax*distance*EPS_SMOOTH_LINE_FACTOR));
-      
-      xstep=dx/steps;
-      ystep=dy/steps;
-
-      rstep=dr/steps;
-      gstep=dg/steps;
-      bstep=db/steps;
-
-      xnext=vertex[0].x;
-      ynext=vertex[0].y;
-      rnext=vertex[0].red;
-      gnext=vertex[0].green;
-      bnext=vertex[0].blue;
-
-      if (!print_colour) {
-	rnext+=(gnext+bnext);
-	rnext/=3.0;
-	gnext=rnext;
-	bnext=rnext;
-      }
-
-      xnext -= xstep/2.0;
-      ynext -= ystep/2.0;
-      rnext -= rstep/2.0;
-      gnext -= gstep/2.0;
-      bnext -= bstep/2.0;
-    } else {
-      steps=0;
-    }
-    if (print_colour) {
-      fprintf (file, "%g %g %g setrgbcolor\n",
-	       vertex[0].red, vertex[0].green, vertex[0].blue);
-    } else {
-      intensity = (vertex[0].red + vertex[0].green + vertex[0].blue) / 3.0;
-      fprintf (file, "%g %g %g setrgbcolor\n",
-	       intensity, intensity, intensity);
-    }      
-    fprintf (file, "%g %g moveto\n", vertex[0].x, vertex[0].y);
-
-    for (i=0; i<steps; i++) {
-
-      xnext += xstep;
-      ynext += ystep;
-      rnext += rstep;
-      gnext += gstep;
-      bnext += bstep;
-
-      fprintf (file, "%g %g lineto stroke\n", xnext, ynext);
-      fprintf (file, "%g %g %g setrgbcolor\n", rnext, gnext, bnext);
-      fprintf (file, "%g %g moveto\n", xnext, ynext);
-    }
-    fprintf (file, "%g %g lineto stroke\n", vertex[1].x, vertex[1].y);
-
-    loc += 14;
-    break;
-
-  case GL_POLYGON_TOKEN:
-    nvertices = G4int (*loc);
-    loc++;
-    vertex=(Feedback3Dcolor*)loc;
-    if (nvertices>0) {
-      red=vertex[0].red;
-      green=vertex[0].green;
-      blue=vertex[0].blue;
-      smooth=0;
-      
-      if (!print_colour) {
-	red+=(green+blue);
-	red/=3.0;
-	green=red;
-	blue=red;
-      }
-      
-      if (print_colour) {
-	for (i=1; i<nvertices; i++) {
-	  if (red!=vertex[i].red || green!=vertex[i].green || blue!=vertex[i].blue) {
-	    smooth=1;
-	    break;
-	  }
-	}
-      } else {
-	for (i=1; i<nvertices; i++) {
-	  intensity = vertex[i].red + vertex[i].green + vertex[i].blue;
-	  intensity/=3.0;
-	  if (red!=intensity) {
-	    smooth=1;
-	    break;
-	  }
-	}
-      }
-
-      if (smooth) {
-	G4int triOffset;
-	for (i=0; i<nvertices-2; i++) {
-	  triOffset = i*7;
-	  fprintf (file, "[%g %g %g %g %g %g]",
-		   vertex[0].x, vertex[i+1].x, vertex[i+2].x,
-		   vertex[0].y, vertex[i+1].y, vertex[i+2].y);
-	  if (print_colour) {
-	    fprintf (file, " [%g %g %g] [%g %g %g] [%g %g %g] gouraudtriangle\n",
-		     vertex[0].red, vertex[0].green, vertex[0].blue,
-		     vertex[i+1].red, vertex[i+1].green, vertex[i+1].blue,
-		     vertex[i+2].red, vertex[i+2].green, vertex[i+2].blue);
-	  } else {
-
-	    intensity = vertex[0].red + vertex[0].green + vertex[0].blue;
-	    intensity/=3.0;
-	    fprintf (file, " [%g %g %g]", intensity, intensity, intensity);
-
-	    intensity = vertex[1].red + vertex[1].green + vertex[1].blue;
-	    intensity/=3.0;
-	    fprintf (file, " [%g %g %g]", intensity, intensity, intensity);
-
-	    intensity = vertex[2].red + vertex[2].green + vertex[2].blue;
-	    intensity/=3.0;
-	    fprintf (file, " [%g %g %g] gouraudtriangle\n", intensity, intensity, intensity);
-	  }
-	}
-      } else {
-	fprintf (file, "newpath\n");
-	fprintf (file, "%g %g %g setrgbcolor\n", red, green, blue);
-	fprintf (file, "%g %g moveto\n", vertex[0].x, vertex[0].y);
-	for (i=1; i<nvertices; i++) {
-	  fprintf (file, "%g %g lineto\n", vertex[i].x, vertex[i].y);
-	}
-	fprintf (file, "closepath fill\n\n");
-      }
-    }
-    loc += nvertices*7;
-    break;
-
-  case GL_POINT_TOKEN:
-    vertex=(Feedback3Dcolor*)loc;
-    if (print_colour) {
-      fprintf (file, "%g %g %g setrgbcolor\n", vertex[0].red, vertex[0].green, vertex[0].blue);
-    } else {
-      intensity = vertex[0].red + vertex[0].green + vertex[0].blue;
-      intensity/=3.0;
-      fprintf (file, "%g %g %g setrgbcolor\n", intensity, intensity, intensity);
-    }      
-    fprintf(file, "%g %g %g 0 360 arc fill\n\n", vertex[0].x, vertex[0].y, pointSize / 2.0);
-    loc += 7;           /* Each vertex element in the feedback
-                           buffer is 7 GLfloats. */
-    break;
-  default:
-    /* XXX Left as an excersie to the reader. */
-    static G4bool spewPrimitiveEPSWarned = false;
-    if (!spewPrimitiveEPSWarned) {
-      std::ostringstream oss;
-      oss <<
-	"Incomplete implementation.  Unexpected token (" << token << ")."
-	"\n  (Seems to be caused by text.)";
-      G4Exception("G4OpenGLXViewer::spewPrimitiveEPS",
-		  "Unexpected token",
-		  JustWarning,
-		  oss.str().c_str());
-      spewPrimitiveEPSWarned = true;
-    }
-  }
-  return loc;
-}
-
-typedef struct G4OpenGLXViewerDepthIndex {
-  GLfloat *ptr;
-  GLfloat depth;
-} DepthIndex;
-
-extern "C" {
-  int G4OpenGLXViewercompare(const void *a, const void *b)
-  {
-    const DepthIndex *p1 = (DepthIndex *) a;
-    const DepthIndex *p2 = (DepthIndex *) b;
-    GLfloat diff = p2->depth - p1->depth;
-    
-    if (diff > 0.0) {
-      return 1;
-    } else if (diff < 0.0) {
-      return -1;
-    } else {
-      return 0;
-    }
-  }
-}
-
-void G4OpenGLXViewer::spewSortedFeedback(FILE * file, GLint size, GLfloat * buffer)
-{
-  int token;
-  GLfloat *loc, *end;
-  Feedback3Dcolor *vertex;
-  GLfloat depthSum;
-  int nprimitives, item;
-  DepthIndex *prims;
-  int nvertices, i;
-
-  end = buffer + size;
-
-  /* Count how many primitives there are. */
-  nprimitives = 0;
-  loc = buffer;
-  while (loc < end) {
-    token = int (*loc);
-    loc++;
-    switch (token) {
-    case GL_LINE_TOKEN:
-    case GL_LINE_RESET_TOKEN:
-      loc += 14;
-      nprimitives++;
-      break;
-    case GL_POLYGON_TOKEN:
-      nvertices = int (*loc);
-      loc++;
-      loc += (7 * nvertices);
-      nprimitives++;
-      break;
-    case GL_POINT_TOKEN:
-      loc += 7;
-      nprimitives++;
-      break;
-    default:
-      /* XXX Left as an excersie to the reader. */
-      static G4bool spewSortedFeedbackWarned = false;
-      if (!spewSortedFeedbackWarned) {
-	std::ostringstream oss;
-	oss <<
-	  "Incomplete implementation.  Unexpected token (" << token << ")."
-	  "\n  (Seems to be caused by text.)";
-	G4Exception("G4OpenGLXViewer::spewSortedFeedback",
-		    "Unexpected token",
-		    JustWarning,
-		    oss.str().c_str());
-	spewSortedFeedbackWarned = true;
-      }
-      nprimitives++;
-    }
-  }
-
-  /* Allocate an array of pointers that will point back at
-     primitives in the feedback buffer.  There will be one
-     entry per primitive.  This array is also where we keep the
-     primitive's average depth.  There is one entry per
-     primitive  in the feedback buffer. */
-  prims = (DepthIndex *) malloc(sizeof(DepthIndex) * nprimitives);
-
-  item = 0;
-  loc = buffer;
-  while (loc < end) {
-    prims[item].ptr = loc;  /* Save this primitive's location. */
-    token = int (*loc);
-    loc++;
-    switch (token) {
-    case GL_LINE_TOKEN:
-    case GL_LINE_RESET_TOKEN:
-      vertex = (Feedback3Dcolor *) loc;
-      depthSum = vertex[0].z + vertex[1].z;
-      prims[item].depth = depthSum / 2.0;
-      loc += 14;
-      break;
-    case GL_POLYGON_TOKEN:
-      nvertices = int (*loc);
-      loc++;
-      vertex = (Feedback3Dcolor *) loc;
-      depthSum = vertex[0].z;
-      for (i = 1; i < nvertices; i++) {
-        depthSum += vertex[i].z;
-      }
-      prims[item].depth = depthSum / nvertices;
-      loc += (7 * nvertices);
-      break;
-    case GL_POINT_TOKEN:
-      vertex = (Feedback3Dcolor *) loc;
-      prims[item].depth = vertex[0].z;
-      loc += 7;
-      break;
-    default:
-      /* XXX Left as an excersie to the reader. */
-      assert(1);
-    }
-    item++;
-  }
-  assert(item == nprimitives);
-
-  /* Sort the primitives back to front. */
-  qsort(prims, nprimitives, sizeof(DepthIndex), G4OpenGLXViewercompare);
-
-  /* Understand that sorting by a primitives average depth
-     doesn't allow us to disambiguate some cases like self
-     intersecting polygons.  Handling these cases would require
-     breaking up the primitives.  That's too involved for this
-     example.  Sorting by depth is good enough for lots of
-     applications. */
-
-  /* Emit the Encapsulated PostScript for the primitives in
-     back to front order. */
-  for (item = 0; item < nprimitives; item++) {
-    (void) spewPrimitiveEPS(file, prims[item].ptr);
-  }
-
-  free(prims);
-}
-
-GLXContext G4OpenGLXViewer::create_GL_print_context(XVisualInfo*& pvi) {
-  
-  pvi = glXChooseVisual (dpy,
-			 XDefaultScreen (dpy),
-			 snglBuf_RGBA);
-
-  if (!pvi) {
-    pvi = glXChooseVisual (dpy,
-			   XDefaultScreen (dpy),
-			   dblBuf_RGBA);
-  }
-
-  return glXCreateContext (dpy,
-			   pvi,
-			   NULL,
-			   False);
+GLubyte* G4OpenGLXViewer::grabPixels (int inColor, unsigned int width, unsigned int height) {
+  
+  GLubyte* buffer;
+  GLint swapbytes, lsbfirst, rowlength;
+  GLint skiprows, skippixels, alignment;
+  GLenum format;
+  int size;
+
+  if (inColor) {
+    format = GL_RGB;
+    size = width*height*3;
+  } else {
+    format = GL_LUMINANCE;
+    size = width*height*1;
+  }
+
+  buffer = new GLubyte[size];
+  if (buffer == NULL)
+    return NULL;
+
+  glGetIntegerv (GL_UNPACK_SWAP_BYTES, &swapbytes);
+  glGetIntegerv (GL_UNPACK_LSB_FIRST, &lsbfirst);
+  glGetIntegerv (GL_UNPACK_ROW_LENGTH, &rowlength);
+
+  glGetIntegerv (GL_UNPACK_SKIP_ROWS, &skiprows);
+  glGetIntegerv (GL_UNPACK_SKIP_PIXELS, &skippixels);
+  glGetIntegerv (GL_UNPACK_ALIGNMENT, &alignment);
+
+  glPixelStorei (GL_UNPACK_SWAP_BYTES, GL_FALSE);
+  glPixelStorei (GL_UNPACK_LSB_FIRST, GL_FALSE);
+  glPixelStorei (GL_UNPACK_ROW_LENGTH, 0);
+
+  glPixelStorei (GL_UNPACK_SKIP_ROWS, 0);
+  glPixelStorei (GL_UNPACK_SKIP_PIXELS, 0);
+  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
+
+  glReadPixels (0, 0, (GLsizei)width, (GLsizei)height, format, GL_UNSIGNED_BYTE, (GLvoid*) buffer);
+
+  glPixelStorei (GL_UNPACK_SWAP_BYTES, swapbytes);
+  glPixelStorei (GL_UNPACK_LSB_FIRST, lsbfirst);
+  glPixelStorei (GL_UNPACK_ROW_LENGTH, rowlength);
+  
+  glPixelStorei (GL_UNPACK_SKIP_ROWS, skiprows);
+  glPixelStorei (GL_UNPACK_SKIP_PIXELS, skippixels);
+  glPixelStorei (GL_UNPACK_ALIGNMENT, alignment);
+  
+  return buffer;
 }
 
@@ -1040,51 +615,20 @@
 }
 
-GLubyte* G4OpenGLXViewer::grabPixels (int inColor, unsigned int width, unsigned int height) {
-  
-  GLubyte* buffer;
-  GLint swapbytes, lsbfirst, rowlength;
-  GLint skiprows, skippixels, alignment;
-  GLenum format;
-  int size;
-
-  if (inColor) {
-    format = GL_RGB;
-    size = width*height*3;
-  } else {
-    format = GL_LUMINANCE;
-    size = width*height*1;
-  }
-
-  buffer = new GLubyte[size];
-  if (buffer == NULL)
-    return NULL;
-
-  glGetIntegerv (GL_UNPACK_SWAP_BYTES, &swapbytes);
-  glGetIntegerv (GL_UNPACK_LSB_FIRST, &lsbfirst);
-  glGetIntegerv (GL_UNPACK_ROW_LENGTH, &rowlength);
-
-  glGetIntegerv (GL_UNPACK_SKIP_ROWS, &skiprows);
-  glGetIntegerv (GL_UNPACK_SKIP_PIXELS, &skippixels);
-  glGetIntegerv (GL_UNPACK_ALIGNMENT, &alignment);
-
-  glPixelStorei (GL_UNPACK_SWAP_BYTES, GL_FALSE);
-  glPixelStorei (GL_UNPACK_LSB_FIRST, GL_FALSE);
-  glPixelStorei (GL_UNPACK_ROW_LENGTH, 0);
-
-  glPixelStorei (GL_UNPACK_SKIP_ROWS, 0);
-  glPixelStorei (GL_UNPACK_SKIP_PIXELS, 0);
-  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
-
-  glReadPixels (0, 0, (GLsizei)width, (GLsizei)height, format, GL_UNSIGNED_BYTE, (GLvoid*) buffer);
-
-  glPixelStorei (GL_UNPACK_SWAP_BYTES, swapbytes);
-  glPixelStorei (GL_UNPACK_LSB_FIRST, lsbfirst);
-  glPixelStorei (GL_UNPACK_ROW_LENGTH, rowlength);
-  
-  glPixelStorei (GL_UNPACK_SKIP_ROWS, skiprows);
-  glPixelStorei (GL_UNPACK_SKIP_PIXELS, skippixels);
-  glPixelStorei (GL_UNPACK_ALIGNMENT, alignment);
-  
-  return buffer;
+GLXContext G4OpenGLXViewer::create_GL_print_context(XVisualInfo*& pvi) {
+  
+  pvi = glXChooseVisual (dpy,
+			 XDefaultScreen (dpy),
+			 snglBuf_RGBA);
+
+  if (!pvi) {
+    pvi = glXChooseVisual (dpy,
+			   XDefaultScreen (dpy),
+			   dblBuf_RGBA);
+  }
+
+  return glXCreateContext (dpy,
+			   pvi,
+			   NULL,
+			   False);
 }
 
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmBox.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmBox.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmBox.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmBox.cc,v 1.6 2006/06/29 21:19:40 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Box container class
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmConvenienceRoutines.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmConvenienceRoutines.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmConvenienceRoutines.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmConvenienceRoutines.cc,v 1.11 2006/06/29 21:19:42 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmFourArrowButtons.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmFourArrowButtons.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmFourArrowButtons.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmFourArrowButtons.cc,v 1.5 2006/06/29 21:19:44 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Four arrow buttons class. Inherits from G4OpenGLXmVWidgetComponent
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmFramedBox.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmFramedBox.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmFramedBox.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmFramedBox.cc,v 1.6 2006/06/29 21:19:46 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Framed box container class
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmMainMenubarCallbacks.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmMainMenubarCallbacks.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmMainMenubarCallbacks.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmMainMenubarCallbacks.cc,v 1.13 2006/06/29 21:19:48 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmPanningCallbacks.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmPanningCallbacks.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmPanningCallbacks.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmPanningCallbacks.cc,v 1.8 2006/06/29 21:19:50 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmPushButton.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmPushButton.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmPushButton.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmPushButton.cc,v 1.6 2006/06/29 21:19:52 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Push button class. Inherits from G4OpenGLXmVWidgetComponent
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmRadioButton.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmRadioButton.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmRadioButton.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmRadioButton.cc,v 1.6 2006/06/29 21:19:54 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Radio button class. Inherits from G4OpenGLXmVWidgetComponent
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmRotationCallbacks.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmRotationCallbacks.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmRotationCallbacks.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmRotationCallbacks.cc,v 1.14 2006/06/29 21:19:56 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmSeparator.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmSeparator.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmSeparator.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmSeparator.cc,v 1.5 2006/06/29 21:19:58 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Separator class. Inherits from G4OpenGLXmVWidgetComponent
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmSliderBar.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmSliderBar.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmSliderBar.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmSliderBar.cc,v 1.7 2006/06/29 21:20:00 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Slider bar class. Inherits from G4OpenGLXmVWidgetComponent
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmStyleCallbacks.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmStyleCallbacks.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmStyleCallbacks.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmStyleCallbacks.cc,v 1.14 2006/06/29 21:20:02 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmTextField.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmTextField.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmTextField.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmTextField.cc,v 1.7 2006/06/29 21:20:04 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Text field class. Inherits from G4OpenGLXmVWidgetComponent
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmTopLevelShell.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmTopLevelShell.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmTopLevelShell.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmTopLevelShell.cc,v 1.5 2006/06/29 21:20:06 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Top level shell class
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetComponent.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetComponent.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetComponent.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmVWidgetComponent.cc,v 1.5 2006/06/29 21:20:08 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Base class for all Motif component widgets
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetContainer.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetContainer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetContainer.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmVWidgetContainer.cc,v 1.5 2006/06/29 21:20:10 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Base class for all Motif container widgets
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetObject.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetObject.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetObject.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmVWidgetObject.cc,v 1.5 2006/06/29 21:20:12 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Virtual base class for all Motif widgets.
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetShell.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetShell.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLXmVWidgetShell.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLXmVWidgetShell.cc,v 1.5 2006/06/29 21:20:14 gunter Exp $
-// GEANT4 tag $Name: geant4-08-01-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 //Base class for all Motif shell widgets
